import { BaseController } from '@/api/BaseController';
import { RequestOption } from '@/common/http/types';
import { ANY_OBJECT } from '@/types/generic';
import { TableData } from '@/common/types/table';
import { useUrlBuilder } from '@/common/hooks/useUrl';
import TourProjectGroupPurchaseApply from '@/types/table/tourProjectGroupPurchaseApply';
import { TourismProjectData } from '@/api/generated/tourismProjectController';
import { TourUserData } from '@/api/generated/tourUserController';
import { API_CONTEXT } from '../config';

const { buildGetUrl } = useUrlBuilder();

export interface TourProjectGroupPurchaseApplyData extends TourProjectGroupPurchaseApply {
  tourismProject?: TourismProjectData;
  tourUser?: TourUserData;
  __cascade_add_temp_id__?: string | number | undefined;
}

export default class TourProjectGroupPurchaseApplyController extends BaseController {
  static list(params: ANY_OBJECT, httpOptions?: RequestOption) {
    return super.post<TableData<TourProjectGroupPurchaseApplyData>>(API_CONTEXT + '/app/tourProjectGroupPurchaseApply/list', params, httpOptions);
  }
  static view(params: ANY_OBJECT, httpOptions?: RequestOption) {
    return super.get<TourProjectGroupPurchaseApplyData>(API_CONTEXT + '/app/tourProjectGroupPurchaseApply/view', params, httpOptions);
  }
  static export(params: ANY_OBJECT, fileName: string) {
    return super.download(API_CONTEXT + '/app/tourProjectGroupPurchaseApply/export', params, fileName);
  }
  static import(params: ANY_OBJECT) {
    return super.upload(API_CONTEXT + '/app/tourProjectGroupPurchaseApply/import', params);
  }
  static printUrl(params: ANY_OBJECT) {
    return buildGetUrl(API_CONTEXT + '/app/tourProjectGroupPurchaseApply/print', params);
  }
  static add(params: ANY_OBJECT, httpOptions?: RequestOption) {
    return super.post(API_CONTEXT + '/app/tourProjectGroupPurchaseApply/add', params, httpOptions);
  }
  static update(params: ANY_OBJECT, httpOptions?: RequestOption) {
    return super.post(API_CONTEXT + '/app/tourProjectGroupPurchaseApply/update', params, httpOptions);
  }
  static delete(params: ANY_OBJECT, httpOptions?: RequestOption) {
    return super.post(API_CONTEXT + '/app/tourProjectGroupPurchaseApply/delete', params, httpOptions);
  }
  static deleteBatch(params: ANY_OBJECT, httpOptions?: RequestOption) {
    return super.post(API_CONTEXT + '/app/tourProjectGroupPurchaseApply/deleteBatch', params, httpOptions);
  }
}
